<template>
  <div class="profile-wrapper">
    <div><b>nick: </b>{{ user.nick }}</div>
    <div><b>email: </b>{{ user.email }}</div>
    <div>
      <div
        style="
          display: flex;
          flex-direction: row;
          justify-content: space-between;
        "
      >
        <div style="display: flex; flex-direction: column">
          <q-input
            style="width: 200px"
            label="hasło"
            dense
            :disable="!passwordEnabled"
            v-model="password"
            type="password"
            autofocus
          />
          <ProgressBar :color="metterColor" :value="metterValue" />
        </div>
        <q-btn
          @click="
            () => {
              if (passwordTimer !== 0) {
                changePassword();
              } else {
                unblockPasswordDialog = true;
              }
            }
          "
          flat
          :label="
            passwordTimer === 0
              ? `Odblokuj hasło`
              : `Zmień hasło (${passwordTimer})`
          "
        />
      </div>
      <q-input
        style="width: 200px"
        label="powtórz hasło"
        dense
        :disable="!passwordEnabled"
        v-model="repeatPassword"
        type="password"
        autofocus
      />
      <AutocompleteCity @city="setCity" />
      <h3>Zdjęcie profilowe</h3>
      <br />
      <q-img :src="user.photos.profile" width="200px" />
      <q-btn
        flat
        label="Zmień"
        @click="
          () => {
            profilePhotoChanging = true;
          }
        "
      /><br />
      <h4>Zdjęcia dodatkowe</h4>
      <br />
      <div v-for="(photo, index) in user.photos.rest" :key="index">
        <q-img :src="photo" width="200px" />
        <q-btn
          flat
          label="Zmień"
          @click="
            () => {
              restPhotoChanging = true;
              restPhotoChangingNumber = index;
            }
          "
        />
        <q-btn
          @click="
            () => {
              removeAdditionalPhoto(index);
            }
          "
          flat
          label="Usuń"
        />
      </div>
      <q-btn
        flat
        label="Dodaj"
        @click="
          () => {
            restPhotoChanging = true;
            restPhotoChangingNumber = user.photos.rest.length;
          }
        "
      /><br />
      <!-- <q-uploader
        ref="uploader"
        url="http://localhost:4444/upload"
        color="teal"
        flat
        bordered
        style="max-width: 300px"
      /> -->
      <q-btn @click="submit" flat label="Zapisz" />
      <q-dialog v-model="unblockPasswordDialog">
        <q-card-section
          class="q-pt-none"
          style="display: flex; flex-direction: column; justify-content: center"
        >
          <q-input
            style="width: 200px"
            label="Podaj dotychczasowe hasło"
            dense
            v-model="oldPassword"
            type="password"
            autofocus
          />
          <q-btn @click="unlockPassword" flat label="Odblokuj" />
        </q-card-section>
      </q-dialog>
      <q-dialog v-model="profilePhotoChanging">
        <q-card-section
          class="q-pt-none"
          style="
            display: flex;
            flex-direction: column;
            justify-content: center;
            background: #aaaaaa;
          "
        >
          Zmień zdejęcie profilowe
          <q-uploader
            ref="uploader"
            url="http://localhost:4444/upload"
            color="teal"
            flat
            bordered
            style="max-width: 300px"
          />
          <q-btn @click="changeProfilePhoto" flat label="Zmień" />
        </q-card-section>
      </q-dialog>

      <q-dialog v-model="restPhotoChanging">
        <q-card-section
          class="q-pt-none"
          style="
            display: flex;
            flex-direction: column;
            justify-content: center;
            background: #aaaaaa;
          "
        >
          Zmień zdjęcie dodatkowe
          <q-uploader
            ref="uploaderAdditional"
            url="http://localhost:4444/upload"
            color="teal"
            flat
            bordered
            style="max-width: 300px"
          />
          <q-btn @click="changeAdditionalPhoto" flat label="Zmień" />
        </q-card-section>
      </q-dialog>

      <q-dialog v-model="restPhotoAdding">
        <q-card-section
          class="q-pt-none"
          style="
            display: flex;
            flex-direction: column;
            justify-content: center;
            background: #aaaaaa;
          "
        >
          Dodaj zdjęcie
          <q-uploader
            ref="uploaderAdditionalAdd"
            url="http://localhost:4444/upload"
            color="teal"
            flat
            bordered
            style="max-width: 300px"
          />
          <q-btn @click="changeAdditionalPhoto" flat label="Zmień" />
        </q-card-section>
      </q-dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import { ref, watch } from 'vue';
import { useRouter } from 'vue-router';
import { useQuasar } from 'quasar';
import { PasswordMeter } from 'password-meter';
import { QUploader } from 'quasar';

import { api } from '../boot/axios';
import { useUserStore } from '../stores/user';

import City from '../interfaces/City';

import ProgressBar from '../components//ProgressBar.vue';
import AutocompleteCity from '../components/AutocompleteCity.vue';

defineOptions({
  name: 'ProfilePage',
});

const $q = useQuasar();
const metter = new PasswordMeter();

const userStore = useUserStore();
const { user } = userStore;
const router = useRouter();
const password = ref<string>('');
const repeatPassword = ref<string>('');
const passwordEnabled = ref<boolean>(false);
const unblockPasswordDialog = ref<boolean>(false);
const oldPassword = ref<string>('');
const passwordTimer = ref<number>(0);
const metterValue = ref<number>(0);
const metterColor = ref<string>('');
const passwordComplexity = ref<boolean>(false);
const city = ref<City | null>(null);
const uploader = ref<InstanceType<typeof QUploader> | null>(null);
const uploaderAdditional = ref<InstanceType<typeof QUploader> | null>(null);
const uploaderAdditionalAdd = ref<InstanceType<typeof QUploader> | null>(null);
const base64 = ref<string>('');
const profilePhotoChanging = ref<boolean>(false);
const restPhotoChangingNumber = ref<number>(0);
const restPhotoChanging = ref<boolean>(false);
const restPhotoAdding = ref<boolean>(false);
function unlockPassword() {
  api
    .post('/user/authorize', {
      uuid: user.uuid,
      password: oldPassword.value,
    })
    .then(({ data }) => {
      if (data.status === 'OK') {
        unblockPasswordDialog.value = false;
        oldPassword.value = '';
        passwordEnabled.value = true;
        passwordTimer.value = 60;
        const interval = setInterval(() => {
          if (passwordTimer.value === 0) {
            clearInterval(interval);
            passwordEnabled.value = false;
            return;
          }
          passwordTimer.value -= 1;
        }, 1000);
        console.log('Password OK');
      } else {
        console.log('Wrong password');
      }
    });
}

function changePassword() {
  const messages = [];
  if (password.value !== repeatPassword.value) {
    messages.push('Hasła się różnią');
  }
  if (!passwordComplexity.value) {
    messages.push('Za słabe hasło');
  }

  if (messages.length > 0) {
    for (let i = 0, max = messages.length; i < max; i++) {
      $q.notify({
        message: messages[i],
        color: 'red',
        timeout: 6000,
      });
    }
    return;
  }

  api
    .post('/user/change-password', {
      uuid: user.uuid,
      password: password.value,
    })
    .then(({ data }) => {
      if (data.status === 'OK') {
        $q.notify({
          message: 'Hasło zostało zmienione',
          color: 'green',
          timeout: 6000,
        });
        passwordTimer.value = 0;
      }
    });
}

watch(password, (newValue) => {
  const result = metter.getResult(newValue);
  metterValue.value = result.percent;
  console.log(result);
  switch (result.status) {
    case 'veryWeak':
      metterColor.value = '#B71C1C';
      passwordComplexity.value = false;
      break;
    case 'weak':
      metterColor.value = '#e65100';
      passwordComplexity.value = false;
      break;
    case 'medium':
      metterColor.value = '#f57f17';
      passwordComplexity.value = false;
      break;
    case 'strong':
      metterColor.value = '#33691e';
      passwordComplexity.value = true;
      break;
    case 'perfect':
      metterColor.value = '#33691e';
      passwordComplexity.value = true;
      break;
  }
});

function setCity(cityObject: City) {
  city.value = cityObject;
}

function submit() {
  api
    .put('/user/change', {
      uuid: user.uuid,
      password: password.value,
      city: city.value,
      profileImage: user.photos.profile,
      restOfImages: user.photos.rest,
    })
    .then(({ data }) => {
      const { status, message } = data;
      if (status === 'OK') {
        $q.notify({
          message: 'Zmiany zostały wprowadzone',
          color: 'green',
          timeout: 6000,
        });

        setTimeout(() => {
          router.push('/');
        }, 10000);
      }
      if (status === 'NOT OK' && message === 'user exists') {
        $q.notify({
          message: 'Wybrany użytkownik jest już zarejestrowany',
          color: 'red',
          timeout: 6000,
        });
      }

      if (status == 'NOT OK' && message == 'Profile image too large') {
        $q.notify({
          message:
            'Dopuszczalna wielkość zdjęcia profilowego to 15MB. Spróbuj je skadrować lub/i skompresować',
          color: 'red',
          timeout: 6000,
        });
      }
    });
}
function changeProfilePhoto() {
  if (uploader.value) {
    const reader = new FileReader();
    reader.readAsDataURL(uploader.value.files[0]);

    reader.onload = () => {
      if (typeof reader.result === 'string') {
        base64.value = reader.result;
        userStore.setProfilePhoto(base64.value);
        profilePhotoChanging.value = false;
      }
    };
  }
}

function changeAdditionalPhoto() {
  if (uploaderAdditional.value) {
    const reader = new FileReader();
    reader.readAsDataURL(uploaderAdditional.value.files[0]);

    reader.onload = () => {
      if (typeof reader.result === 'string') {
        base64.value = reader.result;
        userStore.setRestPhoto(base64.value, restPhotoChangingNumber.value);
        profilePhotoChanging.value = false;
      }
    };
  }
}
function removeAdditionalPhoto(index: number) {
  userStore.removeRestPhoto(index);
}
</script>
<style scoped lang="scss">
.profile-wrapper {
  padding: 30px;
}
</style>
